## nghttp2 1.18.1

=== CMakeLists.txt ===
# nghttp2 - HTTP/2 C Library
#
# Copyright (c) 2012, 2013, 2014, 2015 Tatsuhiro Tsujikawa
# Copyright (c) 2016 Peter Wu <peter@lekensteyn.nl>
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

cmake_minimum_required(VERSION 3.0)
# XXX using 1.8.90 instead of 1.9.0-DEV
project(nghttp2 VERSION 1.18.1)

# See versioning rule:
#  http://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
set(LT_CURRENT  26)
set(LT_REVISION 3)
set(LT_AGE      12)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(Version)

math(EXPR LT_SOVERSION "${LT_CURRENT} - ${LT_AGE}")
set(LT_VERSION "${LT_SOVERSION}.${LT_AGE}.${LT_REVISION}")
set(PACKAGE_VERSION     "${PROJECT_VERSION}")
HexVersion(PACKAGE_VERSION_NUM ${PROJECT_VERSION_MAJOR} ${PROJECT_VERSION_MINOR} ${PROJECT_VERSION_PATCH})

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the build type" FORCE)

  # Include "None" as option to disable any additional (optimization) flags,
  # relying on just CMAKE_C_FLAGS and CMAKE_CXX_FLAGS (which are empty by
  # default). These strings are presented in cmake-gui.
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "None" "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

include(GNUInstallDirs)

# For Python bindings and documentation
# (Must be called before PythonLibs for matching versions.)
find_package(PythonInterp)

# Auto-detection of features that can be toggled
find_package(OpenSSL 1.0.1)
find_package(Libev 4.11)
find_package(Libcares 1.7.5)
find_package(ZLIB 1.2.3)
if(OPENSSL_FOUND AND LIBEV_FOUND AND ZLIB_FOUND)
  set(ENABLE_APP_DEFAULT ON)
else()
  set(ENABLE_APP_DEFAULT OFF)
endif()
find_package(Jansson  2.5)
set(ENABLE_HPACK_TOOLS_DEFAULT ${JANSSON_FOUND})
# 2.0.8 is required because we use evconnlistener_set_error_cb()
find_package(Libevent 2.0.8 COMPONENTS libevent openssl)
set(ENABLE_EXAMPLES_DEFAULT ${LIBEVENT_OPENSSL_FOUND})
find_package(Cython)
find_package(PythonLibs)
if(CYTHON_FOUND AND PYTHONLIBS_FOUND)
  set(ENABLE_PYTHON_BINDINGS_DEFAULT ON)
else()
  set(ENABLE_PYTHON_BINDINGS_DEFAULT OFF)
endif()

find_package(LibXml2 2.7.7)
set(WITH_LIBXML2_DEFAULT    ${LIBXML2_FOUND})
find_package(Jemalloc)
set(WITH_JEMALLOC_DEFAULT   ${JEMALLOC_FOUND})
find_package(Spdylay 1.3.2)
set(WITH_SPDYLAY_DEFAULT    ${SPDYLAY_FOUND})

include(CMakeOptions.txt)

if(ENABLE_LIB_ONLY AND (ENABLE_APP OR ENABLE_HPACK_TOOLS OR ENABLE_EXAMPLES OR
  ENABLE_PYTHON_BINDINGS))
  # Remember when disabled options are disabled for later diagnostics.
  set(ENABLE_LIB_ONLY_DISABLED_OTHERS 1)
else()
  set(ENABLE_LIB_ONLY_DISABLED_OTHERS 0)
endif()
if(ENABLE_LIB_ONLY)
  set(ENABLE_APP            OFF)
  set(ENABLE_HPACK_TOOLS    OFF)
  set(ENABLE_EXAMPLES       OFF)
  set(ENABLE_PYTHON_BINDINGS OFF)
endif()

# Do not disable assertions based on CMAKE_BUILD_TYPE.
foreach(_build_type "Release" "MinSizeRel" "RelWithDebInfo")
  foreach(_lang C CXX)
    string(TOUPPER "CMAKE_${_lang}_FLAGS_${_build_type}" _var)
    string(REGEX REPLACE "(^| )[/-]D *NDEBUG($| )" "" ${_var} "${${_var}}")
  endforeach()
endforeach()

#
# If we're running GCC or clang define _U_ to be "__attribute__((unused))"
# so we can use _U_ to flag unused function parameters and not get warnings
# about them. Otherwise, define _U_ to be an empty string so that _U_ used
# to flag an unused function parameters will compile with other compilers.
#
# XXX - similar hints for other compilers?
#
if(CMAKE_C_COMPILER_ID MATCHES "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  set(HINT_UNUSED_PARAM   "__attribute__((unused))")
  set(HINT_NORETURN       "__attribute__((noreturn))")
else()
  set(HINT_UNUSED_PARAM)
  set(HINT_NORETURN)
endif()

include(ExtractValidFlags)
foreach(_cxx1x_flag -std=c++11 -std=c++0x)
  extract_valid_cxx_flags(_cxx1x_flag_supported ${_cxx1x_flag})
  if(_cxx1x_flag_supported)
    set(CXX1XCXXFLAGS ${_cxx1x_flag})
    break()
  endif()
endforeach()

include(CMakePushCheckState)
include(CheckCXXSourceCompiles)
cmake_push_check_state()
set(CMAKE_REQUIRED_DEFINITIONS "${CXX1XCXXFLAGS}")
# Check that std::future is available.
check_cxx_source_compiles("
#include <vector>
#include <future>
int main() { std::vector<std::future<int>> v; }" HAVE_STD_FUTURE)
# Check that std::map::emplace is available for g++-4.7.
check_cxx_source_compiles("
#include <map>
int main() { std::map<int, int>().emplace(1, 2); }" HAVE_STD_MAP_EMPLACE)
cmake_pop_check_state()


# Checks for libraries.
# Additional libraries required for programs under src directory.
set(APP_LIBRARIES)

if(ENABLE_PYTHON_BINDINGS)
  if(NOT (CYTHON_FOUND AND PYTHONLIBS_FOUND))
    message(FATAL_ERROR "python bindings were requested "
      "(ENABLE_PYTHON_BINDINGS=1) but dependencies are not met.")
  endif()
  if(NOT PYTHON_VERSION_STRING STREQUAL PYTHONLIBS_VERSION_STRING)
    message(FATAL_ERROR
      "Python executable and library must have the same version!"
      " Found Python ${PYTHON_VERSION_STRING} and"
      " PythonLibs ${PYTHONLIBS_VERSION_STRING}"
    )
  endif()
endif()

set(CMAKE_THREAD_PREFER_PTHREAD 1)
find_package(Threads)
if(CMAKE_USE_PTHREADS_INIT)
  list(APPEND APP_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
endif()
# XXX android and C++, is this still needed in cmake?
# case "$host" in
#   *android*)
#     android_build=yes
#     # android does not need -pthread, but needs followng 3 libs for C++
#     APPLDFLAGS="$APPLDFLAGS -lstdc++ -latomic -lsupc++"

# dl: openssl requires libdl when it is statically linked.
# XXX shouldn't ${CMAKE_DL_LIBS} be appended to OPENSSL_LIBRARIES instead of
# APP_LIBRARIES if it is really specific to OpenSSL?

find_package(CUnit 2.1)
enable_testing()
set(HAVE_CUNIT      ${CUNIT_FOUND})
if(HAVE_CUNIT)
  add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
endif()

# openssl (for src)
set(HAVE_OPENSSL    ${OPENSSL_FOUND})
if(OPENSSL_FOUND)
  set(OPENSSL_INCLUDE_DIRS  ${OPENSSL_INCLUDE_DIR})
else()
  set(OPENSSL_INCLUDE_DIRS  "")
  set(OPENSSL_LIBRARIES     "")
endif()
# libev (for src)
set(HAVE_LIBEV      ${LIBEV_FOUND})
set(HAVE_ZLIB       ${ZLIB_FOUND})
set(HAVE_LIBEVENT_OPENSSL ${LIBEVENT_FOUND})
if(LIBEVENT_FOUND)
  # Must both link the core and openssl libraries.
  set(LIBEVENT_OPENSSL_LIBRARIES ${LIBEVENT_LIBRARIES})
endif()
# libc-ares (for src)
set(HAVE_LIBCARES   ${LIBCARES_FOUND})
if(LIBCARES_FOUND)
  set(LIBCARES_INCLUDE_DIRS ${LIBCARES_INCLUDE_DIR})
else()
  set(LIBCARES_INCLUDE_DIRS "")
  set(LIBCARES_LIBRARIES    "")
endif()
# jansson (for src/nghttp, src/deflatehd and src/inflatehd)
set(HAVE_JANSSON    ${JANSSON_FOUND})
# libxml2 (for src/nghttp)
set(HAVE_LIBXML2    ${LIBXML2_FOUND})
if(LIBXML2_FOUND)
  set(LIBXML2_INCLUDE_DIRS  ${LIBXML2_INCLUDE_DIR})
else()
  set(LIBXML2_INCLUDE_DIRS  "")
  set(LIBXML2_LIBRARIES     "")
endif()
# jemalloc
set(HAVE_JEMALLOC   ${JEMALLOC_FOUND})
# spdylay (for src/nghttpx and src/h2load)
set(HAVE_SPDYLAY    ${SPDYLAY_FOUND})

if(ENABLE_ASIO_LIB)
  find_package(Boost 1.54.0 REQUIRED system thread)
endif()

# The nghttp, nghttpd and nghttpx under src depend on zlib, OpenSSL and libev
if(ENABLE_APP AND NOT (ZLIB_FOUND AND OPENSSL_FOUND AND LIBEV_FOUND))
  message(FATAL_ERROR "Applications were requested (ENABLE_APP=1) but dependencies are not met.")
endif()

# HPACK tools requires jansson
if(ENABLE_HPACK_TOOLS AND NOT HAVE_JANSSON)
  message(FATAL_ERROR "HPACK tools were requested (ENABLE_HPACK_TOOLS=1) but dependencies are not met.")
endif()

# C++ library libnghttp2_asio
if(ENABLE_EXAMPLES AND NOT (OPENSSL_FOUND AND LIBEVENT_OPENSSL_FOUND))
  message(FATAL_ERROR "examples were requested (ENABLE_EXAMPLES=1) but dependencies are not met.")
endif()

# third-party http-parser only be built when needed
if(ENABLE_EXAMPLES OR ENABLE_APP OR ENABLE_HPACK_TOOLS OR ENABLE_ASIO_LIB)
  set(ENABLE_THIRD_PARTY 1)
  # mruby (for src/nghttpx)
  set(HAVE_MRUBY      ${WITH_MRUBY})
  set(HAVE_NEVERBLEED ${WITH_NEVERBLEED})
else()
  set(HAVE_MRUBY 0)
  set(HAVE_NEVERBLEED 0)
endif()

# Checks for header files.
include(CheckIncludeFile)
check_include_file("arpa/inet.h"    HAVE_ARPA_INET_H)
check_include_file("fcntl.h"        HAVE_FCNTL_H)
check_include_file("inttypes.h"     HAVE_INTTYPES_H)
check_include_file("limits.h"       HAVE_LIMITS_H)
check_include_file("netdb.h"        HAVE_NETDB_H)
check_include_file("netinet/in.h"   HAVE_NETINET_IN_H)
check_include_file("pwd.h"          HAVE_PWD_H)
check_include_file("sys/socket.h"   HAVE_SYS_SOCKET_H)
check_include_file("sys/time.h"     HAVE_SYS_TIME_H)
check_include_file("syslog.h"       HAVE_SYSLOG_H)
check_include_file("time.h"         HAVE_TIME_H)
check_include_file("unistd.h"       HAVE_UNISTD_H)

include(CheckTypeSize)
# Checks for typedefs, structures, and compiler characteristics.
# AC_TYPE_SIZE_T
check_type_size("ssize_t" SIZEOF_SSIZE_T)
if(SIZEOF_SSIZE_T STREQUAL "")
  # ssize_t is a signed type in POSIX storing at least -1.
  # Set it to "int" to match the behavior of AC_TYPE_SSIZE_T (autotools).
  set(ssize_t int)
endif()
# AC_TYPE_UINT8_T
# AC_TYPE_UINT16_T
# AC_TYPE_UINT32_T
# AC_TYPE_UINT64_T
# AC_TYPE_INT8_T
# AC_TYPE_INT16_T
# AC_TYPE_INT32_T
# AC_TYPE_INT64_T
# AC_TYPE_OFF_T
# AC_TYPE_PID_T
# AC_TYPE_UID_T
# XXX To support inline for crappy compilers, see https://cmake.org/Wiki/CMakeTestInline
# AC_C_INLINE
# XXX is AC_SYS_LARGEFILE still needed for modern systems?
# add_definitions(-D_FILE_OFFSET_BITS=64)

include(CheckStructHasMember)
check_struct_has_member("struct tm" tm_gmtoff time.h HAVE_STRUCT_TM_TM_GMTOFF)

# Check size of pointer to decide we need 8 bytes alignment adjustment.
check_type_size("int *"   SIZEOF_INT_P)
check_type_size("time_t"  SIZEOF_TIME_T)

# Checks for library functions.
include(CheckFunctionExists)
check_function_exists(_Exit     HAVE__EXIT)
check_function_exists(accept4   HAVE_ACCEPT4)

include(CheckSymbolExists)
# XXX does this correctly detect initgroups (un)availability on cygwin?
check_symbol_exists(initgroups grp.h HAVE_DECL_INITGROUPS)
if(NOT HAVE_DECL_INITGROUPS AND HAVE_UNISTD_H)
  # FreeBSD declares initgroups() in unistd.h
  check_symbol_exists(initgroups unistd.h HAVE_DECL_INITGROUPS2)
  if(HAVE_DECL_INITGROUPS2)
    set(HAVE_DECL_INITGROUPS 1)
  endif()
endif()

set(WARNCFLAGS)
set(WARNCXXFLAGS)
if(CMAKE_C_COMPILER_ID MATCHES "MSVC")
  if(ENABLE_WERROR)
    set(WARNCFLAGS    /WX)
    set(WARNCXXFLAGS  /WX)
  endif()
else()
  if(ENABLE_WERROR)
    extract_valid_c_flags(WARNCFLAGS    -Werror)
    extract_valid_c_flags(WARNCXXFLAGS  -Werror)
  endif()

  # For C compiler
  extract_valid_c_flags(WARNCFLAGS
    -Wall
    -Wextra
    -Wmissing-prototypes
    -Wstrict-prototypes
    -Wmissing-declarations
    -Wpointer-arith
    -Wdeclaration-after-statement
    -Wformat-security
    -Wwrite-strings
    -Wshadow
    -Winline
    -Wnested-externs
    -Wfloat-equal
    -Wundef
    -Wendif-labels
    -Wempty-body
    -Wcast-align
    -Wclobbered
    -Wvla
    -Wpragmas
    -Wunreachable-code
    -Waddress

=== doc/CMakeLists.txt ===
# Generated documents
set(APIDOCS
  macros.rst
  enums.rst
  types.rst
  nghttp2_check_header_name.rst
  nghttp2_check_header_value.rst
  nghttp2_hd_deflate_bound.rst
  nghttp2_hd_deflate_change_table_size.rst
  nghttp2_hd_deflate_del.rst
  nghttp2_hd_deflate_get_dynamic_table_size.rst
  nghttp2_hd_deflate_get_max_dynamic_table_size.rst
  nghttp2_hd_deflate_get_num_table_entries.rst
  nghttp2_hd_deflate_get_table_entry.rst
  nghttp2_hd_deflate_hd.rst
  nghttp2_hd_deflate_hd_vec.rst
  nghttp2_hd_deflate_new.rst
  nghttp2_hd_deflate_new2.rst
  nghttp2_hd_inflate_change_table_size.rst
  nghttp2_hd_inflate_del.rst
  nghttp2_hd_inflate_end_headers.rst
  nghttp2_hd_inflate_get_dynamic_table_size.rst
  nghttp2_hd_inflate_get_max_dynamic_table_size.rst
  nghttp2_hd_inflate_get_num_table_entries.rst
  nghttp2_hd_inflate_get_table_entry.rst
  nghttp2_hd_inflate_hd.rst
  nghttp2_hd_inflate_hd2.rst
  nghttp2_hd_inflate_new.rst
  nghttp2_hd_inflate_new2.rst
  nghttp2_http2_strerror.rst
  nghttp2_is_fatal.rst
  nghttp2_nv_compare_name.rst
  nghttp2_option_del.rst
  nghttp2_option_new.rst
  nghttp2_option_set_builtin_recv_extension_type.rst
  nghttp2_option_set_max_deflate_dynamic_table_size.rst
  nghttp2_option_set_max_reserved_remote_streams.rst
  nghttp2_option_set_max_send_header_block_length.rst
  nghttp2_option_set_no_auto_ping_ack.rst
  nghttp2_option_set_no_auto_window_update.rst
  nghttp2_option_set_no_http_messaging.rst
  nghttp2_option_set_no_recv_client_magic.rst
  nghttp2_option_set_peer_max_concurrent_streams.rst
  nghttp2_option_set_user_recv_extension_type.rst
  nghttp2_pack_settings_payload.rst
  nghttp2_priority_spec_check_default.rst
  nghttp2_priority_spec_default_init.rst
  nghttp2_priority_spec_init.rst
  nghttp2_rcbuf_decref.rst
  nghttp2_rcbuf_get_buf.rst
  nghttp2_rcbuf_incref.rst
  nghttp2_select_next_protocol.rst
  nghttp2_session_callbacks_del.rst
  nghttp2_session_callbacks_new.rst
  nghttp2_session_callbacks_set_before_frame_send_callback.rst
  nghttp2_session_callbacks_set_data_source_read_length_callback.rst
  nghttp2_session_callbacks_set_error_callback.rst
  nghttp2_session_callbacks_set_on_begin_frame_callback.rst
  nghttp2_session_callbacks_set_on_begin_headers_callback.rst
  nghttp2_session_callbacks_set_on_data_chunk_recv_callback.rst
  nghttp2_session_callbacks_set_on_extension_chunk_recv_callback.rst
  nghttp2_session_callbacks_set_on_frame_not_send_callback.rst
  nghttp2_session_callbacks_set_on_frame_recv_callback.rst
  nghttp2_session_callbacks_set_on_frame_send_callback.rst
  nghttp2_session_callbacks_set_on_header_callback.rst
  nghttp2_session_callbacks_set_on_header_callback2.rst
  nghttp2_session_callbacks_set_on_invalid_frame_recv_callback.rst
  nghttp2_session_callbacks_set_on_invalid_header_callback.rst
  nghttp2_session_callbacks_set_on_invalid_header_callback2.rst
  nghttp2_session_callbacks_set_on_stream_close_callback.rst
  nghttp2_session_callbacks_set_pack_extension_callback.rst
  nghttp2_session_callbacks_set_recv_callback.rst
  nghttp2_session_callbacks_set_select_padding_callback.rst
  nghttp2_session_callbacks_set_send_callback.rst
  nghttp2_session_callbacks_set_send_data_callback.rst
  nghttp2_session_callbacks_set_unpack_extension_callback.rst
  nghttp2_session_change_stream_priority.rst
  nghttp2_session_check_request_allowed.rst
  nghttp2_session_check_server_session.rst
  nghttp2_session_client_new.rst
  nghttp2_session_client_new2.rst
  nghttp2_session_client_new3.rst
  nghttp2_session_consume.rst
  nghttp2_session_consume_connection.rst
  nghttp2_session_consume_stream.rst
  nghttp2_session_create_idle_stream.rst
  nghttp2_session_del.rst
  nghttp2_session_find_stream.rst
  nghttp2_session_get_effective_local_window_size.rst
  nghttp2_session_get_effective_recv_data_length.rst
  nghttp2_session_get_hd_deflate_dynamic_table_size.rst
  nghttp2_session_get_hd_inflate_dynamic_table_size.rst
  nghttp2_session_get_last_proc_stream_id.rst
  nghttp2_session_get_local_settings.rst
  nghttp2_session_get_local_window_size.rst
  nghttp2_session_get_next_stream_id.rst
  nghttp2_session_get_outbound_queue_size.rst
  nghttp2_session_get_remote_settings.rst
  nghttp2_session_get_remote_window_size.rst
  nghttp2_session_get_root_stream.rst
  nghttp2_session_get_stream_effective_local_window_size.rst
  nghttp2_session_get_stream_effective_recv_data_length.rst
  nghttp2_session_get_stream_local_close.rst
  nghttp2_session_get_stream_local_window_size.rst
  nghttp2_session_get_stream_remote_close.rst
  nghttp2_session_get_stream_remote_window_size.rst
  nghttp2_session_get_stream_user_data.rst
  nghttp2_session_mem_recv.rst
  nghttp2_session_mem_send.rst
  nghttp2_session_recv.rst
  nghttp2_session_resume_data.rst
  nghttp2_session_send.rst
  nghttp2_session_server_new.rst
  nghttp2_session_server_new2.rst
  nghttp2_session_server_new3.rst
  nghttp2_session_set_local_window_size.rst
  nghttp2_session_set_next_stream_id.rst
  nghttp2_session_set_stream_user_data.rst
  nghttp2_session_terminate_session.rst
  nghttp2_session_terminate_session2.rst
  nghttp2_session_upgrade.rst
  nghttp2_session_upgrade2.rst
  nghttp2_session_want_read.rst
  nghttp2_session_want_write.rst
  nghttp2_set_debug_vprintf_callback.rst
  nghttp2_stream_get_first_child.rst
  nghttp2_stream_get_next_sibling.rst
  nghttp2_stream_get_parent.rst
  nghttp2_stream_get_previous_sibling.rst
  nghttp2_stream_get_state.rst
  nghttp2_stream_get_sum_dependency_weight.rst
  nghttp2_stream_get_weight.rst
  nghttp2_strerror.rst
  nghttp2_submit_altsvc.rst
  nghttp2_submit_data.rst
  nghttp2_submit_extension.rst
  nghttp2_submit_goaway.rst
  nghttp2_submit_headers.rst
  nghttp2_submit_ping.rst
  nghttp2_submit_priority.rst
  nghttp2_submit_push_promise.rst
  nghttp2_submit_request.rst
  nghttp2_submit_response.rst
  nghttp2_submit_rst_stream.rst
  nghttp2_submit_settings.rst
  nghttp2_submit_shutdown_notice.rst
  nghttp2_submit_trailer.rst
  nghttp2_submit_window_update.rst
  nghttp2_version.rst
)

set(MAN_PAGES
  nghttp.1
  nghttpd.1
  nghttpx.1
  h2load.1
)

# Other .rst files from the source tree that need to be copied
# XXX move them to sources/ and create .in files?
set(RST_FILES
  README.rst
  programmers-guide.rst
  nghttp.1.rst
  nghttpd.1.rst
  nghttpx.1.rst
  h2load.1.rst
)

# XXX unused for now
set(EXTRA_DIST
  mkapiref.py
  ${RST_FILES}
  ${APIDOCS}
  sources/index.rst
  sources/tutorial-client.rst
  sources/tutorial-server.rst
  sources/tutorial-hpack.rst
  sources/nghttpx-howto.rst
  sources/h2load-howto.rst
  sources/libnghttp2_asio.rst
  sources/python-apiref.rst
  sources/building-android-binary.rst
  sources/contribute.rst
  _exts/sphinxcontrib/LICENSE.rubydomain
  _exts/sphinxcontrib/__init__.py
  _exts/sphinxcontrib/rubydomain.py
  _themes/sphinx_rtd_theme/__init__.py
  _themes/sphinx_rtd_theme/breadcrumbs.html
  _themes/sphinx_rtd_theme/footer.html
  _themes/sphinx_rtd_theme/layout.html
  _themes/sphinx_rtd_theme/layout_old.html
  _themes/sphinx_rtd_theme/search.html
  _themes/sphinx_rtd_theme/searchbox.html
  _themes/sphinx_rtd_theme/static/css/badge_only.css
  _themes/sphinx_rtd_theme/static/css/theme.css
  _themes/sphinx_rtd_theme/static/fonts/FontAwesome.otf
  _themes/sphinx_rtd_theme/static/fonts/fontawesome-webfont.eot
  _themes/sphinx_rtd_theme/static/fonts/fontawesome-webfont.svg
  _themes/sphinx_rtd_theme/static/fonts/fontawesome-webfont.ttf
  _themes/sphinx_rtd_theme/static/fonts/fontawesome-webfont.woff
  _themes/sphinx_rtd_theme/static/js/theme.js
  _themes/sphinx_rtd_theme/theme.conf
  _themes/sphinx_rtd_theme/versions.html
  ${MAN_PAGES}
  bash_completion/nghttp
  bash_completion/nghttpd
  bash_completion/nghttpx
  bash_completion/h2load
)

# Based on Makefile for Sphinx documentation

# You can set these variables from the command line.
set(SPHINXOPTS)
set(SPHINXBUILD sphinx-build)
set(PAPER)
set(BUILDDIR    manual)

# Internal variables.
set(PAPEROPT_a4     -D latex_paper_size=a4)
set(PAPEROPT_letter -D latex_paper_size=letter)
set(ALLSPHINXOPTS   -d ${BUILDDIR}/doctrees ${PAPEROPT_${PAPER}} ${SPHINXOPTS} .)

# "Please use `make <target>' where <target> is one of"
# "  html       to make standalone HTML files"
# "  dirhtml    to make HTML files named index.html in directories"
# "  singlehtml to make a single large HTML file"
# "  pickle     to make pickle files"
# "  json       to make JSON files"
# "  htmlhelp   to make HTML files and a HTML help project"
# "  qthelp     to make HTML files and a qthelp project"
# "  devhelp    to make HTML files and a Devhelp project"
# "  epub       to make an epub"
# "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
# "  latexpdf   to make LaTeX files and run them through pdflatex"
# "  text       to make text files"
# "  man        to make manual pages"
# "  changes    to make an overview of all changed/added/deprecated items"
# "  linkcheck  to check all external links for integrity"
# "  doctest    to run all doctests embedded in the documentation (if enabled)"


# Copy files for out-of-tree builds
if(NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
  set(RST_BUILD_FILES)
  foreach(rstfile IN LISTS RST_FILES)
    set(outfile "${CMAKE_CURRENT_BINARY_DIR}/${rstfile}")
    add_custom_command(OUTPUT "${outfile}"
      COMMAND ${CMAKE_COMMAND} -E copy
              "${CMAKE_CURRENT_SOURCE_DIR}/${rstfile}" "${outfile}"
      DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${rstfile}"
    )
    list(APPEND RST_BUILD_FILES "${outfile}")
  endforeach()
else()
  set(RST_BUILD_FILES "${RST_FILES}")
endif()

set(apiref_SOURCES
  ${CMAKE_BINARY_DIR}/lib/includes/nghttp2/nghttp2ver.h
  ${CMAKE_SOURCE_DIR}/lib/includes/nghttp2/nghttp2.h
)
# Generates apiref.rst and other files
add_custom_command(
  OUTPUT
    apiref.rst
    ${APIDOCS}
  COMMAND
    "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/mkapiref.py"
    apiref.rst macros.rst enums.rst types.rst .
    ${apiref_SOURCES}
  DEPENDS
    ${RST_BUILD_FILES}
    ${apiref_SOURCES}
)



set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${BUILDDIR}")

# Invokes sphinx-build and prints the given messages when completed
function(sphinxbuild builder)
  set(echo_commands)
  foreach(message IN LISTS ARGN)
    list(APPEND echo_commands COMMAND ${CMAKE_COMMAND} -E echo "${message}")
  endforeach()
  add_custom_target(${builder}
    COMMAND "${SPHINXBUILD}" -b ${builder} ${ALLSPHINXOPTS} "${BUILDDIR}/${builder}"
    COMMAND ${CMAKE_COMMAND} -E echo
    ${echo_commands}
    VERBATIM
    DEPENDS apiref.rst
  )
endfunction()

foreach(builder html dirhtml singlehtml)
  sphinxbuild(${builder}
    "Build finished. The HTML pages are in ${BUILDDIR}/${builder}.")
endforeach()
sphinxbuild(pickle  "Build finished; now you can process the pickle files.")
sphinxbuild(json    "Build finished; now you can process the JSON files.")
sphinxbuild(htmlhelp
  "Build finished; now you can run HTML Help Workshop with the"
  ".hhp project file in ${BUILDDIR}/htmlhelp."
)
sphinxbuild(qthelp
  "Build finished; now you can run \"qcollectiongenerator\" with the"
  ".qhcp project file in ${BUILDDIR}/qthelp, like this:"
  "# qcollectiongenerator ${BUILDDIR}/qthelp/nghttp2.qhcp"
  "To view the help file:"
  "# assistant -collectionFile ${BUILDDIR}/qthelp/nghttp2.qhc"
)
sphinxbuild(devhelp
  "Build finished."
  "To view the help file:"
  "# mkdir -p ~/.local/share/devhelp/nghttp2"
  "# ln -s ${BUILDDIR}/devhelp ~/.local/share/devhelp/nghttp2"
  "# devhelp"
)
sphinxbuild(epub    "Build finished. The epub file is in ${BUILDDIR}/epub.")
sphinxbuild(latex
  "Build finished; the LaTeX files are in ${BUILDDIR}/latex."
  "Run `make' in that directory to run these through (pdf)latex"
  "(use `make latexpdf' here to do that automatically)."
)

# Invoke the Makefile generated by sphinx
add_custom_target(latexpdf
  COMMAND ${CMAKE_COMMAND} -E echo "Running LaTeX files through pdflatex..."
  COMMAND make -C "${BUILDDIR}/latex" all-pdf

=== examples/CMakeLists.txt ===
if(ENABLE_EXAMPLES)
  file(GLOB c_sources *.c)
  set_source_files_properties(${c_sources} PROPERTIES
    COMPILE_FLAGS "${WARNCFLAGS}")
  file(GLOB cxx_sources *.cc)
  set_source_files_properties(${cxx_sources} PROPERTIES
    COMPILE_FLAGS "${WARNCXXFLAGS} ${CXX1XCXXFLAGS}")

  include_directories(
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/lib/includes
    ${CMAKE_BINARY_DIR}/lib/includes
    ${CMAKE_SOURCE_DIR}/src/includes
    ${CMAKE_SOURCE_DIR}/third-party

    ${LIBEVENT_INCLUDE_DIRS}
    ${OPENSSL_INCLUDE_DIRS}
  )

  link_libraries(
    nghttp2
    ${LIBEVENT_OPENSSL_LIBRARIES}
    ${OPENSSL_LIBRARIES}
    ${APP_LIBRARIES}
  )

  add_executable(client           client.c $<TARGET_OBJECTS:http-parser>)
  add_executable(libevent-client  libevent-client.c $<TARGET_OBJECTS:http-parser>)
  add_executable(libevent-server  libevent-server.c $<TARGET_OBJECTS:http-parser>)
  add_executable(deflate          deflate.c $<TARGET_OBJECTS:http-parser>)

  if(ENABLE_ASIO_LIB)
    foreach(name asio-sv asio-sv2 asio-cl asio-cl2)
      add_executable(${name} ${name}.cc $<TARGET_OBJECTS:http-parser>)
      target_include_directories(${name} PRIVATE
        ${OPENSSL_INCLUDE_DIRS}
        ${Boost_INCLUDE_DIRS}
      )
      target_link_libraries(${name}
        nghttp2
        nghttp2_asio
        ${JEMALLOC_LIBRARIES}
        ${OPENSSL_LIBRARIES}
        ${Boost_LIBRARIES}
        ${APP_LIBRARIES}
      )
    endforeach()
  endif()
endif()

=== src/CMakeLists.txt ===
add_subdirectory(includes)

file(GLOB c_sources *.c)
set_source_files_properties(${c_sources} PROPERTIES
  COMPILE_FLAGS "${WARNCFLAGS}")
file(GLOB cxx_sources *.cc)
set_source_files_properties(${cxx_sources} PROPERTIES
  COMPILE_FLAGS "${WARNCXXFLAGS} ${CXX1XCXXFLAGS}")

include_directories(
  "${CMAKE_SOURCE_DIR}/lib/includes"
  "${CMAKE_BINARY_DIR}/lib/includes"
  "${CMAKE_SOURCE_DIR}/lib"
  "${CMAKE_SOURCE_DIR}/src/includes"
  "${CMAKE_SOURCE_DIR}/third-party"

  ${JEMALLOC_INCLUDE_DIRS}
  ${SPDYLAY_INCLUDE_DIRS}
  ${LIBXML2_INCLUDE_DIRS}
  ${LIBEV_INCLUDE_DIRS}
  ${OPENSSL_INCLUDE_DIRS}
  ${LIBCARES_INCLUDE_DIRS}
  ${JANSSON_INCLUDE_DIRS}
  ${ZLIB_INCLUDE_DIRS}
)

# XXX per-target?
link_libraries(
  nghttp2
  ${JEMALLOC_LIBRARIES}
  ${SPDYLAY_LIBRARIES}
  ${LIBXML2_LIBRARIES}
  ${LIBEV_LIBRARIES}
  ${OPENSSL_LIBRARIES}
  ${LIBCARES_LIBRARIES}
  ${JANSSON_LIBRARIES}
  ${ZLIB_LIBRARIES}
  ${APP_LIBRARIES}
)

if(ENABLE_APP)
  set(HELPER_OBJECTS
    util.cc
    http2.cc timegm.c app_helper.cc nghttp2_gzip.c
  )

  # nghttp client
  set(NGHTTP_SOURCES
    ${HELPER_OBJECTS}
    nghttp.cc
    ssl.cc
  )
  if(HAVE_LIBXML2)
    list(APPEND NGHTTP_SOURCES HtmlParser.cc)
  endif()

  # nghttpd
  set(NGHTTPD_SOURCES
    ${HELPER_OBJECTS}
    nghttpd.cc
    ssl.cc
    HttpServer.cc
  )

  # h2load
  set(H2LOAD_SOURCES
    util.cc
    http2.cc h2load.cc
    timegm.c
    ssl.cc
    h2load_http2_session.cc
    h2load_http1_session.cc
  )
  if(HAVE_SPDYLAY)
    list(APPEND H2LOAD_SOURCES
      h2load_spdy_session.cc
    )
  endif()


  # Common libnhttpx sources (used for nghttpx and unit tests)
  set(NGHTTPX_SRCS
    util.cc http2.cc timegm.c
    app_helper.cc
    ssl.cc
    shrpx_config.cc
    shrpx_accept_handler.cc
    shrpx_connection_handler.cc
    shrpx_client_handler.cc
    shrpx_http2_upstream.cc
    shrpx_https_upstream.cc
    shrpx_downstream.cc
    shrpx_downstream_connection.cc
    shrpx_http_downstream_connection.cc
    shrpx_http2_downstream_connection.cc
    shrpx_http2_session.cc
    shrpx_downstream_queue.cc
    shrpx_log.cc
    shrpx_http.cc
    shrpx_io_control.cc
    shrpx_ssl.cc
    shrpx_worker.cc
    shrpx_log_config.cc
    shrpx_connect_blocker.cc
    shrpx_live_check.cc
    shrpx_downstream_connection_pool.cc
    shrpx_rate_limit.cc
    shrpx_connection.cc
    shrpx_memcached_dispatcher.cc
    shrpx_memcached_connection.cc
    shrpx_worker_process.cc
    shrpx_signal.cc
    shrpx_router.cc
    shrpx_api_downstream_connection.cc
    shrpx_health_monitor_downstream_connection.cc
    shrpx_exec.cc
    shrpx_dns_resolver.cc
    shrpx_dual_dns_resolver.cc
    shrpx_dns_tracker.cc
    xsi_strerror.c
  )
  if(HAVE_SPDYLAY)
    list(APPEND NGHTTPX_SRCS
      shrpx_spdy_upstream.cc
    )
  endif()
  if(HAVE_MRUBY)
    list(APPEND NGHTTPX_SRCS
      shrpx_mruby.cc
      shrpx_mruby_module.cc
      shrpx_mruby_module_env.cc
      shrpx_mruby_module_request.cc
      shrpx_mruby_module_response.cc
    )
  endif()
  add_library(nghttpx_static STATIC ${NGHTTPX_SRCS})
  set_target_properties(nghttpx_static PROPERTIES ARCHIVE_OUTPUT_NAME nghttpx)

  set(NGHTTPX-bin_SOURCES
    shrpx.cc
  )

  if(HAVE_MRUBY)
    target_link_libraries(nghttpx_static mruby-lib)
  endif()

  if(HAVE_NEVERBLEED)
    target_link_libraries(nghttpx_static neverbleed)
  endif()


  if(HAVE_CUNIT)
    set(NGHTTPX_UNITTEST_SOURCES
      shrpx-unittest.cc
      shrpx_ssl_test.cc
      shrpx_downstream_test.cc
      shrpx_config_test.cc
      shrpx_worker_test.cc
      shrpx_http_test.cc
      shrpx_router_test.cc
      http2_test.cc
      util_test.cc
      nghttp2_gzip_test.c
      nghttp2_gzip.c
      buffer_test.cc
      memchunk_test.cc
      template_test.cc
      base64_test.cc
    )
    add_executable(nghttpx-unittest EXCLUDE_FROM_ALL
      ${NGHTTPX_UNITTEST_SOURCES}
      $<TARGET_OBJECTS:http-parser>
    )
    target_include_directories(nghttpx-unittest PRIVATE ${CUNIT_INCLUDE_DIRS})
    target_compile_definitions(nghttpx-unittest
      PRIVATE "-DNGHTTP2_SRC_DIR=\"${CMAKE_SOURCE_DIR}/src\""
    )
    target_link_libraries(nghttpx-unittest nghttpx_static ${CUNIT_LIBRARIES})
    if(HAVE_MRUBY)
      target_link_libraries(nghttpx-unittest mruby-lib)
    endif()
    if(HAVE_NEVERBLEED)
      target_link_libraries(nghttpx-unittest neverbleed)
    endif()

    add_test(nghttpx-unittest nghttpx-unittest)
    add_dependencies(check nghttpx-unittest)
  endif()

  add_executable(nghttp   ${NGHTTP_SOURCES}   $<TARGET_OBJECTS:http-parser>)
  add_executable(nghttpd  ${NGHTTPD_SOURCES}  $<TARGET_OBJECTS:http-parser>)
  add_executable(nghttpx  ${NGHTTPX-bin_SOURCES} $<TARGET_OBJECTS:http-parser>)
  target_compile_definitions(nghttpx PRIVATE "-DPKGDATADIR=\"${PKGDATADIR}\"")
  target_link_libraries(nghttpx nghttpx_static)
  add_executable(h2load   ${H2LOAD_SOURCES}   $<TARGET_OBJECTS:http-parser>)

  install(TARGETS nghttp nghttpd nghttpx h2load
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
endif()

if(ENABLE_HPACK_TOOLS)
  set(inflatehd_SOURCES
    inflatehd.cc
    comp_helper.c
  )
  set(deflatehd_SOURCES
    deflatehd.cc
    comp_helper.c
  )
  add_executable(inflatehd ${inflatehd_SOURCES})
  add_executable(deflatehd ${deflatehd_SOURCES})
  install(TARGETS inflatehd deflatehd
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
endif()

if(ENABLE_ASIO_LIB)
  set(NGHTTP2_ASIO_SOURCES
    util.cc http2.cc
    ssl.cc
    timegm.c
    asio_common.cc
    asio_io_service_pool.cc
    asio_server_http2.cc
    asio_server_http2_impl.cc
    asio_server.cc
    asio_server_http2_handler.cc
    asio_server_request.cc
    asio_server_request_impl.cc
    asio_server_response.cc
    asio_server_response_impl.cc
    asio_server_stream.cc
    asio_server_serve_mux.cc
    asio_server_request_handler.cc
    asio_server_tls_context.cc
    asio_client_session.cc
    asio_client_session_impl.cc
    asio_client_session_tcp_impl.cc
    asio_client_session_tls_impl.cc
    asio_client_response.cc
    asio_client_response_impl.cc
    asio_client_request.cc
    asio_client_request_impl.cc
    asio_client_stream.cc
    asio_client_tls_context.cc
  )

  add_library(nghttp2_asio SHARED
     ${NGHTTP2_ASIO_SOURCES}
     $<TARGET_OBJECTS:http-parser>
  )
  target_include_directories(nghttp2_asio PRIVATE
    ${OPENSSL_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
  )
  target_link_libraries(nghttp2_asio
    nghttp2
    ${OPENSSL_LIBRARIES}
    ${Boost_LIBRARIES}
  )
  set_target_properties(nghttp2_asio PROPERTIES
    VERSION 1.0.0 SOVERSION 1)

  install(TARGETS nghttp2_asio
    DESTINATION "${CMAKE_INSTALL_LIBDIR}")

  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libnghttp2_asio.pc"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
endif()

=== debian/changelog ===
nghttp2 (1.18.1-1+deb9u1) stretch-security; urgency=high

  * Fix CVE-2019-9511 and CVE-2019-9513

 -- Tomasz Buchert <tomasz@debian.org>  Fri, 23 Aug 2019 19:05:18 +0200

nghttp2 (1.18.1-1) unstable; urgency=medium

  * Imported upstream version 1.18.1

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 08 Jan 2017 12:26:25 +0100

nghttp2 (1.18.0-1) unstable; urgency=medium

  * Imported upstream version 1.18.0
  * debian/*: use debhelper v10 and watch v4
  * Add build dependency on libc-ares-dev

 -- Tomasz Buchert <tomasz@debian.org>  Thu, 29 Dec 2016 09:34:38 +0100

nghttp2 (1.17.0-1) unstable; urgency=medium

  * Imported upstream version 1.17.0

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 27 Nov 2016 15:55:57 +0100

nghttp2 (1.16.0-1) unstable; urgency=medium

  * Imported upstream version 1.16.0

 -- Tomasz Buchert <tomasz@debian.org>  Tue, 25 Oct 2016 20:45:10 +0200

nghttp2 (1.15.0-1) unstable; urgency=medium

  * Imported upstream version 1.15.0

 -- Tomasz Buchert <tomasz@debian.org>  Thu, 29 Sep 2016 08:21:30 +0200

nghttp2 (1.14.1-1) unstable; urgency=medium

  * Imported upstream version 1.14.1

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 11 Sep 2016 08:34:01 +0200

nghttp2 (1.14.0-1) unstable; urgency=medium

  * Imported upstream version 1.14.0

 -- Tomasz Buchert <tomasz@debian.org>  Mon, 29 Aug 2016 20:42:10 +0200

=== debian/control ===
Source: nghttp2
Maintainer: Dave Beckett <dajobe@debian.org>
Uploaders: Tomasz Buchert <tomasz@debian.org>
Section: httpd
Priority: optional
Build-Depends: debhelper (>= 10),
               dpkg-dev (>= 1.17.14),
               libc-ares-dev,
               libcunit1-dev (>= 2.1) <!nocheck>,
               libev-dev (>= 1:4.15),
               libevent-dev (>= 2.0.8),
               libjansson-dev (>= 2.5),
               libjemalloc-dev [!hurd-i386],
               libspdylay-dev (>= 1.3.2),
               libssl-dev (>= 1.0.1),
               libxml2-dev (>= 2.7.7),
               pkg-config,
               zlib1g-dev (>= 1.2.3)
Build-Depends-Indep: python-sphinx
Standards-Version: 3.9.8
Homepage: https://nghttp2.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/nghttp2.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/nghttp2.git

Package: libnghttp2-dev
Suggests: libnghttp2-doc
Section: libdevel
Architecture: any
Conflicts: libnghttp2-3-dev, libnghttp2-4-dev, libnghttp2-5-dev
Replaces: libnghttp2-3-dev, libnghttp2-4-dev, libnghttp2-5-dev
Depends: libnghttp2-14 (= ${binary:Version}), pkg-config, ${misc:Depends}
Description: library implementing HTTP/2 protocol (development files)
 This is an implementation of the Hypertext Transfer Protocol version
 2 in C. The framing layer of HTTP/2 is implemented as a reusable C
 library.
 .
 This package installs development files.

Package: libnghttp2-doc
Section: doc
Architecture: all
Depends: libjs-jquery, libjs-underscore, lynx | www-browser, ${misc:Depends}
Description: library implementing HTTP/2 protocol (documentation)
 This is an implementation of the Hypertext Transfer Protocol version
 2 in C. The framing layer of HTTP/2 is implemented as a reusable C
 library.
 .
 This package installs documentation.

Package: libnghttp2-14
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: library implementing HTTP/2 protocol (shared library)
 This is an implementation of the Hypertext Transfer Protocol version
 2 in C. The framing layer of HTTP/2 is implemented as a reusable C
 library.
 .
 This package installs a shared library.

Package: nghttp2-client
Architecture: any
Multi-Arch: foreign
Depends: libnghttp2-14 (= ${binary:Version}),
         lsb-base (>= 3.2-14),
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: nghttp2 (<< 1.3.4-2~)
Breaks: nghttp2 (<< 1.3.4-2~)
Description: client implementing HTTP/2 protocol
 This is a command line client implementing the HTTP/2 protocol. It
 gives access to many low-level and advanced aspects of the protocol
 and therefore is useful for debugging.

Package: nghttp2-proxy
Architecture: any
Multi-Arch: foreign
Depends: libnghttp2-14 (= ${binary:Version}),
         lsb-base (>= 3.2-14),
         openssl,
         python,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: nghttp2 (<< 1.3.4-2~)
Breaks: nghttp2 (<< 1.3.4-2~)
Description: reverse proxy implementing HTTP/2 protocol
 This is a standalone server implementing the HTTP/2 protocol with
 HTTP/1.1 fallback for clients that do not support it. It can be used
 as a frontend in front of web servers that do not support HTTP/2.

Package: nghttp2-server
Architecture: any
Multi-Arch: foreign
Depends: libnghttp2-14 (= ${binary:Version}),
         lsb-base (>= 3.2-14),
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: nghttp2 (<< 1.3.4-2~)
Breaks: nghttp2 (<< 1.3.4-2~)
Description: server implementing HTTP/2 protocol
 This is a standalone server implementing the HTTP/2 protocol with
 HTTP/1.1 fallback for clients that do not support it. It can be used
 to serve files from a local directory.

Package: nghttp2
Architecture: all
Depends: nghttp2-client (>= ${binary:Version}),
         nghttp2-proxy (>= ${binary:Version}),
         nghttp2-server (>= ${binary:Version}),
         ${misc:Depends}
Description: server, proxy and client implementing HTTP/2
 This package will install a set of programs implementing the HTTP/2
 protocol: a standalone server (nghttp2-server), a reverse proxy
 (nghttp2-proxy) and a client (nghttp2-client). It provides no files
 on its own and is not necessary for these programs to work.

=== debian/rules ===
#!/usr/bin/make -f

# this makes the tests fail
# LDFLAGS += -Wl,--default-symver

override_dh_auto_configure:
	dh_auto_configure -- \
		--enable-python-bindings=no --disable-failmalloc --enable-app

override_dh_installdocs:
	dh_installdocs -A README.rst AUTHORS

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	$(MAKE) html

# don't run tests when building indep packages
override_dh_auto_test-indep:

override_dh_auto_clean:
	dh_auto_clean
	rm -rf doc/manual/html doc/manual/doctrees doc/apiref.rst

override_dh_auto_install-arch: custom_install_init_scripts custom_install_systemd
	dh_auto_install

override_dh_auto_install-indep: custom_install_manual

override_dh_installinit:
	dh_installinit -pnghttp2-proxy --onlyscripts --name=nghttpx

.PHONY: custom_install_manual custom_install_init_scripts custom_install_systemd

DOCDIR="debian/libnghttp2-doc/usr/share/doc/libnghttp2-doc"
custom_install_manual:
	mkdir -p $(DOCDIR)
	cp -pr doc/manual/html/* $(DOCDIR)
	rm $(DOCDIR)/objects.inv
	ln -sf /usr/share/javascript/jquery/jquery.js $(DOCDIR)/_static/jquery.js
	ln -sf /usr/share/javascript/underscore/underscore.js $(DOCDIR)/_static/underscore.js

ETCDIR="debian/nghttp2-proxy/etc"
custom_install_init_scripts:
	install -d $(ETCDIR)/init.d
	sed -e 's,^DAEMON=.*/,DAEMON=/usr/sbin/,' contrib/nghttpx-init > $(ETCDIR)/init.d/nghttpx
	chmod 755 $(ETCDIR)/init.d/nghttpx
	install -d $(ETCDIR)/nghttpx
	# we install our own version of config
	install -m644 debian/nghttpx.conf $(ETCDIR)/nghttpx/nghttpx.conf
	install -d $(ETCDIR)/logrotate.d
	install -p -m644 contrib/nghttpx-logrotate $(ETCDIR)/logrotate.d/nghttpx

# Currently we install our own systemd unit because
# the original one is slightly broken
SYSTEMD="debian/nghttp2-proxy/lib/systemd/system"
custom_install_systemd:
	install -d $(SYSTEMD)
	install -p -m644 debian/nghttpx.service $(SYSTEMD)/nghttpx.service

%:
	dh $@

=== debian/tests/control ===
Tests: proxy-works
Depends: @, nginx
Restrictions: isolation-container

## nghttp2 1.19.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,12 +24,12 @@
 
 cmake_minimum_required(VERSION 3.0)
 # XXX using 1.8.90 instead of 1.9.0-DEV
-project(nghttp2 VERSION 1.18.1)
+project(nghttp2 VERSION 1.19.0)
 
 # See versioning rule:
 #  http://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
 set(LT_CURRENT  26)
-set(LT_REVISION 3)
+set(LT_REVISION 4)
 set(LT_AGE      12)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

=== debian/changelog ===
nghttp2 (1.19.0-1~bpo8+1) jessie-backports; urgency=low

  * Rebuild for jessie-backports.
  * [efe7598] Add Build-Depends on python-sphinxcontrib.rubydomain

 -- Raphaël Halimi <raphael.halimi@gmail.com>  Thu, 02 Feb 2017 22:23:32 +0100

nghttp2 (1.19.0-1) unstable; urgency=medium

  * Imported upstream version 1.19.0

 -- Tomasz Buchert <tomasz@debian.org>  Mon, 30 Jan 2017 22:00:27 +0100

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,8 @@
                libssl-dev (>= 1.0.1),
                libxml2-dev (>= 2.7.7),
                pkg-config,
-               zlib1g-dev (>= 1.2.3)
+               zlib1g-dev (>= 1.2.3),
+               python-sphinxcontrib.rubydomain
 Build-Depends-Indep: python-sphinx
 Standards-Version: 3.9.8
 Homepage: https://nghttp2.org/

## nghttp2 1.25.0

=== debian/changelog ===
nghttp2 (1.25.0-1) unstable; urgency=medium

  * Imported upstream version 1.25.0

 -- Tomasz Buchert <tomasz@debian.org>  Wed, 23 Aug 2017 23:21:44 +0200

nghttp2 (1.24.0-1) unstable; urgency=medium

  * Imported upstream version 1.24.0
  * Bumped Standards-Version to 4.0.0 (no changes needed)

 -- Tomasz Buchert <tomasz@debian.org>  Wed, 05 Jul 2017 08:31:03 +0200

nghttp2 (1.23.1-1) unstable; urgency=medium

  * Imported upstream version 1.23.1

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 03 Jun 2017 10:32:36 +0200

nghttp2 (1.23.0-1) unstable; urgency=medium

  * Imported upstream version 1.23.0

 -- Tomasz Buchert <tomasz@debian.org>  Tue, 30 May 2017 08:49:22 +0200

nghttp2 (1.22.0-1) unstable; urgency=medium

  * Import upstream version 1.22.0

 -- Tomasz Buchert <tomasz@debian.org>  Mon, 01 May 2017 12:55:59 +0200

nghttp2 (1.21.1-1) unstable; urgency=medium

  * Import upstream version 1.21.1

 -- Tomasz Buchert <tomasz@debian.org>  Fri, 14 Apr 2017 09:19:37 +0200

nghttp2 (1.21.0-1) unstable; urgency=medium

  * Import upstream version 1.21.0 (Closes: #858744)

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 02 Apr 2017 11:22:17 +0200

nghttp2 (1.20.0-1) unstable; urgency=medium

  * Import upstream version 1.20.0
  * Revamp the systemd service
  * Make sure spdylay is used

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 19 Mar 2017 14:32:34 +0100

nghttp2 (1.19.0-2) unstable; urgency=medium

  * Add h2load to nghttp2-client (Closes: #853860)

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 04 Feb 2017 11:39:34 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: nghttp2
 Maintainer: Dave Beckett <dajobe@debian.org>
-Uploaders: Tomasz Buchert <tomasz@debian.org>
+Uploaders: Tomasz Buchert <tomasz@debian.org>, Ondřej Surý <ondrej@debian.org>
 Section: httpd
 Priority: optional
 Build-Depends: debhelper (>= 10),
@@ -13,12 +13,12 @@
                libjemalloc-dev [!hurd-i386],
                libspdylay-dev (>= 1.3.2),
                libssl-dev (>= 1.0.1),
+               libsystemd-dev,
                libxml2-dev (>= 2.7.7),
                pkg-config,
-               zlib1g-dev (>= 1.2.3),
-               python-sphinxcontrib.rubydomain
+               zlib1g-dev (>= 1.2.3)
 Build-Depends-Indep: python-sphinx
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: https://nghttp2.org/
 Vcs-Git: git://anonscm.debian.org/collab-maint/nghttp2.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/nghttp2.git

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		--enable-python-bindings=no --disable-failmalloc --enable-app
+		--enable-python-bindings=no --disable-failmalloc --enable-app --with-spdylay
 
 override_dh_installdocs:
 	dh_installdocs -A README.rst AUTHORS
